local windows1251_utf8_map =
{
	[0x80] = "\xd0\x82", // "Ђ"
	[0x81] = "\xd0\x83", // "Ѓ"
	[0x82] = "\xe2\x80\x9a", // "‚"
	[0x83] = "\xd1\x93", // "ѓ"
	[0x84] = "\xe2\x80\x9e", // "„"
	[0x85] = "\xe2\x80\xa6", // "…"
	[0x86] = "\xe2\x80\xa0", // "†"
	[0x87] = "\xe2\x80\xa1", // "‡"
	[0x88] = "\xe2\x82\xac", // "€"
	[0x89] = "\xe2\x80\xb0", // "‰"
	[0x8a] = "\xd0\x89", // "Љ"
	[0x8b] = "\xe2\x80\xb9", // "‹"
	[0x8c] = "\xd0\x8a", // "Њ"
	[0x8d] = "\xd0\x8c", // "Ќ"
	[0x8e] = "\xd0\x8b", // "Ћ"
	[0x8f] = "\xd0\x8f", // "Џ"

	[0x90] = "\xd1\x92", // "ђ"
	[0x91] = "\xe2\x80\x98", // "‘"
	[0x92] = "\xe2\x80\x99", // "’"
	[0x93] = "\xe2\x80\x9c", // "“"
	[0x94] = "\xe2\x80\x9d", // "”"
	[0x95] = "\xe2\x80\xa2", // "•"
	[0x96] = "\xe2\x80\x93", // "–"
	[0x97] = "\xe2\x80\x94", // "—"
	[0x99] = "\xe2\x84\xa2", // "™"
	[0x9a] = "\xd1\x99", // "љ"
	[0x9b] = "\xe2\x80\xba", // "›"
	[0x9c] = "\xd1\x9a", // "њ"
	[0x9d] = "\xd1\x9c", // "ќ"
	[0x9e] = "\xd1\x9b", // "ћ"
	[0x9f] = "\xd1\x9f", // "џ"

	[0xa0] = "\x20", // NBSP
	[0xa1] = "\xd0\x8e", // "Ў"
	[0xa2] = "\xd1\x9e", // "ў"
	[0xa3] = "\xd0\x88", // "Ј"
	[0xa4] = "\xc2\xa4", // "¤"
	[0xa5] = "\xd2\x90", // "Ґ"
	[0xa6] = "\xc2\xa6", // "¦"
	[0xa7] = "\xc2\xa7", // "§"
	[0xa8] = "\xd0\x81", // "Ё"
	[0xa9] = "\xc2\xa9", // "©"
	[0xaa] = "\xd0\x84", // "Є"
	[0xab] = "\xc2\xab", // "«"
	[0xac] = "\xc2\xac", // "¬"
	[0xad] = "\xc2\xad", // SHY
	[0xae] = "\xc2\xae", // "®"
	[0xaf] = "\xd0\x87", // "Ї"

	[0xb0] = "\xc2\xb0", // "°"
	[0xb1] = "\xc2\xb1", // "±"
	[0xb2] = "\xd0\x86", // "І"
	[0xb3] = "\xd1\x96", // "і"
	[0xb4] = "\xd2\x91", // "ґ"
	[0xb5] = "\xc2\xb5", // "µ"
	[0xb6] = "\xc2\xb6", // "¶"
	[0xb7] = "\xc2\xb7", // "·"
	[0xb8] = "\xd1\x91", // "ё"
	[0xb9] = "\xe2\x84\x96", // "№"
	[0xba] = "\xd1\x94", // "є"
	[0xbb] = "\xc2\xbb", // "»"
	[0xbc] = "\xd1\x98", // "ј"
	[0xbd] = "\xd0\x85", // "Ѕ"
	[0xbe] = "\xd1\x95", // "ѕ"
	[0xbf] = "\xd1\x97", // "ї"

	[0xc0] = "\xd0\x90", // "А"
	[0xc1] = "\xd0\x91", // "Б"
	[0xc2] = "\xd0\x92", // "В"
	[0xc3] = "\xd0\x93", // "Г"
	[0xc4] = "\xd0\x94", // "Д"
	[0xc5] = "\xd0\x95", // "Е"
	[0xc6] = "\xd0\x96", // "Ж"
	[0xc7] = "\xd0\x97", // "З"
	[0xc8] = "\xd0\x98", // "И"
	[0xc9] = "\xd0\x99", // "Й"
	[0xca] = "\xd0\x9a", // "К"
	[0xcb] = "\xd0\x9b", // "Л"
	[0xcc] = "\xd0\x9c", // "М"
	[0xcd] = "\xd0\x9d", // "Н"
	[0xce] = "\xd0\x9e", // "О"
	[0xcf] = "\xd0\x9f", // "П"

	[0xd0] = "\xd0\xa0", // "Р"
	[0xd1] = "\xd0\xa1", // "С"
	[0xd2] = "\xd0\xa2", // "Т"
	[0xd3] = "\xd0\xa3", // "У"
	[0xd4] = "\xd0\xa4", // "Ф"
	[0xd5] = "\xd0\xa5", // "Х"
	[0xd6] = "\xd0\xa6", // "Ц"
	[0xd7] = "\xd0\xa7", // "Ч"
	[0xd8] = "\xd0\xa8", // "Ш"
	[0xd9] = "\xd0\xa9", // "Щ"
	[0xda] = "\xd0\xaa", // "Ъ"
	[0xdb] = "\xd0\xab", // "Ы"
	[0xdc] = "\xd0\xac", // "Ь"
	[0xdd] = "\xd0\xad", // "Э"
	[0xde] = "\xd0\xae", // "Ю"
	[0xdf] = "\xd0\xaf", // "Я"

	[0xe0] = "\xd0\xb0", // "а"
	[0xe1] = "\xd0\xb1", // "б"
	[0xe2] = "\xd0\xb2", // "в"
	[0xe3] = "\xd0\xb3", // "г"
	[0xe4] = "\xd0\xb4", // "д"
	[0xe5] = "\xd0\xb5", // "е"
	[0xe6] = "\xd0\xb6", // "ж"
	[0xe7] = "\xd0\xb7", // "з"
	[0xe8] = "\xd0\xb8", // "и"
	[0xe9] = "\xd0\xb9", // "й"
	[0xea] = "\xd0\xba", // "к"
	[0xeb] = "\xd0\xbb", // "л"
	[0xec] = "\xd0\xbc", // "м"
	[0xed] = "\xd0\xbd", // "н"
	[0xee] = "\xd0\xbe", // "о"
	[0xef] = "\xd0\xbf", // "п"

	[0xf0] = "\xd1\x80", // "р"
	[0xf1] = "\xd1\x81", // "с"
	[0xf2] = "\xd1\x82", // "т"
	[0xf3] = "\xd1\x83", // "у"
	[0xf4] = "\xd1\x84", // "ф"
	[0xf5] = "\xd1\x85", // "х"
	[0xf6] = "\xd1\x86", // "ц"
	[0xf7] = "\xd1\x87", // "ч"
	[0xf8] = "\xd1\x88", // "ш"
	[0xf9] = "\xd1\x89", // "щ"
	[0xfa] = "\xd1\x8a", // "ъ"
	[0xfb] = "\xd1\x8b", // "ы"
	[0xfc] = "\xd1\x8c", // "ь"
	[0xfd] = "\xd1\x8d", // "э"
	[0xfe] = "\xd1\x8e", // "ю"
	[0xff] = "\xd1\x8f", // "я"
}

function windows1251_to_utf8(text)
{
	local result = ""

	foreach (idx, charId in text)
	{
		charId += 256

		if (charId in windows1251_utf8_map)
			result += windows1251_utf8_map[charId]
		else
			result += text.slice(idx, idx + 1)
	}

	return result
}